/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Stream.xs. Do not edit this file, edit Stream.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Data/MessagePack/Stream.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_sv_2pvbyte
#define NEED_newSVpvn_flags
#include "ppport.h"

#include <assert.h>
#include <string.h>

#include <msgpack.h>

typedef struct my_unpacker_s my_unpacker_t;

struct my_unpacker_s {
    msgpack_unpacker* unpacker;
    msgpack_unpacked result;
};

static SV*
load_bool(pTHX_ const char* const name) {
    CV* const cv = get_cv(name, GV_ADD);
    dSP;
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    call_sv((SV*)cv, G_SCALAR);
    SPAGAIN;
    SV* const sv = newSVsv(POPs);
    PUTBACK;
    FREETMPS;
    LEAVE;
    assert(sv);
    assert(sv_isobject(sv));
    if(!SvOK(sv)) {
        Perl_croak(aTHX_ "Oops: Failed to load %"SVf, name);
    }
    return sv;
}

static SV* decode_msgpack_object(msgpack_object* obj) {
    SV* res = NULL;
    SV* key_sv;
    AV* av;
    HV* hv;
    size_t i;
    msgpack_object* o;
    msgpack_object_kv* kv;
    const char* key;
    STRLEN len;

    switch (obj->type) {
        case MSGPACK_OBJECT_NIL:
            res = newSV(0);
            break;
        case MSGPACK_OBJECT_BOOLEAN: {
          if (obj->via.boolean == 1) {
            res = newSVsv( load_bool(aTHX_ "Data::MessagePack::true") );
          } else {
            res = newSVsv( load_bool(aTHX_ "Data::MessagePack::false") );
          }
                break;
        }
        case MSGPACK_OBJECT_POSITIVE_INTEGER:
            res = newSVuv(obj->via.u64);
            break;
        case MSGPACK_OBJECT_NEGATIVE_INTEGER:
            res = newSViv(obj->via.i64);
            break;
        case MSGPACK_OBJECT_FLOAT:
            res = newSVnv(obj->via.f64);
            break;
        case MSGPACK_OBJECT_BIN:
            res = newSVpvn(obj->via.bin.ptr, obj->via.bin.size);
            break;
        case MSGPACK_OBJECT_STR:
            res = newSVpvn_utf8(obj->via.str.ptr, obj->via.str.size, 1);
            break;
        case MSGPACK_OBJECT_ARRAY: {
            av = (AV*)sv_2mortal((SV*)newAV());
            o = obj->via.array.ptr;

            for (i = 0; i < obj->via.array.size; i++) {
                av_push(av, decode_msgpack_object(o + i));
            }

            res = newRV_inc((SV*)av);
            break;
        }
        case MSGPACK_OBJECT_MAP: {
            hv = (HV*)sv_2mortal((SV*)newHV());
            kv = obj->via.map.ptr;

            for (i = 0; i < obj->via.map.size; i++) {
                key_sv = decode_msgpack_object(&((kv + i)->key));
                key = SvPV(key_sv, len);

                o   = &((kv + i)->val);
                hv_store(hv, key, len, decode_msgpack_object(o), 0);
                SvREFCNT_dec(key_sv);
            }

            res = newRV_inc((SV*)hv);
            break;
        }
        default:
            Perl_croak(aTHX_ "Unsupported msgpack type: %d", obj->type);
            break;
    }

    return res;
}

#line 124 "lib/Data/MessagePack/Stream.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 268 "lib/Data/MessagePack/Stream.c"

XS_EUPXS(XS_Data__MessagePack__Stream_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__MessagePack__Stream_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_klass");
    {
	SV*	sv_klass = ST(0)
;
#line 121 "lib/Data/MessagePack/Stream.xs"
{
    SV* sv_msgpack;
    HV* hv;
    my_unpacker_t* up;
    char* klass = NULL;

    hv = (HV*)sv_2mortal((SV*)newHV());
    sv_msgpack = sv_2mortal(newRV_inc((SV*)hv));

    klass = SvPV_nolen(sv_klass);

    sv_bless(sv_msgpack, gv_stashpv(klass, 1));

    Newx(up, 1, my_unpacker_t);

    up->unpacker = msgpack_unpacker_new(MSGPACK_UNPACKER_INIT_BUFFER_SIZE);
    if (NULL == up->unpacker) {
        croak("cannot allocate msgpack unpacker");
    }
    msgpack_unpacked_init(&up->result);

    sv_magic((SV*)hv, NULL, PERL_MAGIC_ext, NULL, 0);
    mg_find((SV*)hv, PERL_MAGIC_ext)->mg_obj = (SV*)up;

    ST(0) = sv_msgpack;
    XSRETURN(1);
}
#line 307 "lib/Data/MessagePack/Stream.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__MessagePack__Stream_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__MessagePack__Stream_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "up");
    {
	my_unpacker_t*    up = (my_unpacker_t *)mg_find(SvRV(ST(0)), PERL_MAGIC_ext)->mg_obj
;
#line 152 "lib/Data/MessagePack/Stream.xs"
{
    msgpack_unpacker_free(up->unpacker);
    msgpack_unpacked_destroy(&up->result);
    Safefree(up);
}
#line 328 "lib/Data/MessagePack/Stream.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__MessagePack__Stream_feed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__MessagePack__Stream_feed)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "up, sv_buf");
    {
	my_unpacker_t*    up = (my_unpacker_t *)mg_find(SvRV(ST(0)), PERL_MAGIC_ext)->mg_obj
;
	SV*	sv_buf = ST(1)
;
#line 161 "lib/Data/MessagePack/Stream.xs"
{
    char* buf;
    STRLEN len;

    buf = SvPV(sv_buf, len);

    msgpack_unpacker_reserve_buffer(up->unpacker, len);
    memcpy(msgpack_unpacker_buffer(up->unpacker), buf, len);
    msgpack_unpacker_buffer_consumed(up->unpacker, len);
}
#line 356 "lib/Data/MessagePack/Stream.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__MessagePack__Stream_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__MessagePack__Stream_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "up");
    {
	int	RETVAL;
	dXSTARG;
	my_unpacker_t*    up = (my_unpacker_t *)mg_find(SvRV(ST(0)), PERL_MAGIC_ext)->mg_obj
;
#line 175 "lib/Data/MessagePack/Stream.xs"
{
    RETVAL = msgpack_unpacker_next(up->unpacker, &up->result);
}
#line 377 "lib/Data/MessagePack/Stream.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__MessagePack__Stream_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__MessagePack__Stream_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "up");
    {
	my_unpacker_t*    up = (my_unpacker_t *)mg_find(SvRV(ST(0)), PERL_MAGIC_ext)->mg_obj
;
#line 184 "lib/Data/MessagePack/Stream.xs"
{
    SV* sv_res;

    sv_res = sv_2mortal(decode_msgpack_object(&up->result.data));

    ST(0) = sv_res;
    XSRETURN(1);
}
#line 402 "lib/Data/MessagePack/Stream.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Data__MessagePack__Stream); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Data__MessagePack__Stream)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Data::MessagePack::Stream::new", XS_Data__MessagePack__Stream_new);
        newXS_deffile("Data::MessagePack::Stream::DESTROY", XS_Data__MessagePack__Stream_DESTROY);
        newXS_deffile("Data::MessagePack::Stream::feed", XS_Data__MessagePack__Stream_feed);
        newXS_deffile("Data::MessagePack::Stream::next", XS_Data__MessagePack__Stream_next);
        newXS_deffile("Data::MessagePack::Stream::data", XS_Data__MessagePack__Stream_data);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

